#include <stdio.h>
#include <iostream>
#include <sstream>
#include <memory>
#include <windows.h>
#include <omp.h>
// _msize() returns x for malloc(x)
// _msize() returns x for new char [x]
// _msize() fails for _malloca()/_alloca() - those do not return a heap pointer

int main()
{
	int i[100000] = {0xFF01};
	DWORD Before = GetTickCount(), After, Diff;
	#pragma omp parallel for
	for(int p = 0; p < 100000; ++p)
	{
		#pragma omp parallel for
		for(int j = 0; j < 100000; ++j)
		{
			i[j] = (i[j] >> 8) << 8;
		}
	}
	After = GetTickCount(); Diff = After-Before;
	printf("** DOUBLE BITSHIFT **\r\nTime elasped: %i milliseconds.\r\n", Diff);

	// Reset var
	#pragma omp parallel for
	for(int j = 0; j < 100000; ++j)
	{ 
		i[j] = 0xFF01;
	}

	Before = GetTickCount();
	#pragma omp parallel for
	for(int p = 0; p < 100000; ++p)
	{
		#pragma omp parallel for
		for(int j = 0; j < 100000; ++j)
		{
			i[j] = i[j] & 0xFF;
		}
	}
	After = GetTickCount(); Diff = After-Before;
	printf("** BITMASK **\r\nTime elasped: %i milliseconds.\r\n", Diff);

	system("pause");
}
